program objekty;
uses crt,graph,dos;

type
     tsour=record
             x,y,dx,dy:integer;
           end;
{Kruh}
     tkruh=object
             barva,radius:byte;
             sour:tsour;
             maxx,maxy,minx,miny:integer;
             constructor init(ibarva,iradius:byte;isour:tsour);
             procedure kresli; virtual;
             destructor done; virtual;
           end;
     pkruh=^tkruh;
{Ctverec}
     tctverec=object(tkruh)
             procedure kresli; virtual;
             end;
     pctverec=^tctverec;
{Cara}
     tcara=object(tkruh)
             sour1:tsour;
             constructor init(ibarva:byte;isour,isour1:tsour);
             procedure kresli; virtual;
             end;
     pcara=^tcara;
{Cas}
     tcas=object(tkruh)
            vyska,sirka:word;
            constructor init(ibarva,iradius:byte;isour:tsour);
            procedure kresli; virtual;
            end;
     pcas=^tcas;
{Plocha}
     tplocha=object
            barva: byte;
            constructor init(ibarva:byte);
            procedure kresli; virtual;
            destructor done; virtual;
            end;
     pplocha=^tplocha;
{Cerv}
     tcerv=object(tkruh)
            rychlost: byte;
            uhel: shortint;
            constructor init(ibarva:byte;isour:tsour);
            procedure kresli; virtual;
            end;
     pcerv=^tcerv;

var udalost:word;

{ - - - = = = * * * K R U H * * * = = = - - -}

constructor tkruh.init(ibarva,iradius:byte;isour:tsour);
begin
   barva:=ibarva;
   radius:=iradius;
   sour:=isour;
   maxx:=(getmaxx-radius);
   maxy:=(getmaxy-radius);
   minx:=radius;
   miny:=radius;
end;

procedure tkruh.kresli;
begin
   setcolor(black);
   circle(sour.x,sour.y,radius);
   if sour.x<=minx then begin
                      sour.x:=minx+1;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.x>=maxx then begin
                      sour.x:=maxx;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.y<=miny then begin
                      sour.y:=miny+1;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   if sour.y>=maxy then begin
                      sour.y:=maxy;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   sour.x:=sour.x+sour.dx;
   sour.y:=sour.y+sour.dy;
   setcolor(barva);
   circle(sour.x,sour.y,radius);
end;

destructor tkruh.done;
begin
end;

{ - - - = = = * * * C T V E R E C * * * = = = - - -}

procedure tctverec.kresli;
begin
   setcolor(black);
   rectangle((sour.x-radius div 2),(sour.y-radius div 2),(sour.x+radius div 2),(sour.y+radius div 2));
   if sour.x<=minx then begin
                      sour.x:=minx+1;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.x>=maxx then begin
                      sour.x:=maxx;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.y<=miny then begin
                      sour.y:=miny+1;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   if sour.y>=maxy then begin
                      sour.y:=maxy;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   sour.x:=sour.x+sour.dx;
   sour.y:=sour.y+sour.dy;
   setcolor(barva);
   rectangle((sour.x-radius div 2),(sour.y-radius div 2),(sour.x+radius div 2),(sour.y+radius div 2));
end;

{ - - - = = = * * * C A R A * * * = = = - - -}

constructor tcara.init(ibarva:byte;isour,isour1:tsour);
begin
   barva:=ibarva;
   sour1:=isour1;
   sour:=isour;
   {sour.dx:=isour.dx+1;}
   {sour.dy:=isour.dy+1;}
   maxx:=getmaxx;
   maxy:=getmaxy;
   minx:=0;
   miny:=0;
end;

procedure tcara.kresli;
begin
   setcolor(black);
   line(sour.x,sour.y,sour1.x,sour1.y);
   if sour.x<=minx then begin
                      sour.x:=minx+1;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.x>=maxx then begin
                      sour.x:=maxx;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.y<=miny then begin
                      sour.y:=miny+1;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   if sour.y>=maxy then begin
                      sour.y:=maxy;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   if sour1.x<=minx then begin
                      sour1.x:=minx+1;
                      sour1.dx:=-(sour1.dx * (random(3)+1)) div abs(sour1.dx);
                     end;
   if sour1.x>=maxx then begin
                      sour1.x:=maxx;
                      sour1.dx:=-(sour1.dx * (random(3)+1)) div abs(sour1.dx);
                     end;
   if sour1.y<=miny then begin
                      sour1.y:=miny+1;
                      sour1.dy:=-(sour1.dy * (random(3)+1)) div abs(sour1.dy);
                     end;
   if sour1.y>=maxy then begin
                      sour1.y:=maxy;
                      sour1.dy:=-(sour1.dy * (random(3)+1)) div abs(sour1.dy);
                     end;
   sour.x:=sour.x+sour.dx;
   sour.y:=sour.y+sour.dy;
   sour1.x:=sour1.x+sour1.dx;
   sour1.y:=sour1.y+sour1.dy;
   setcolor(barva);
   line(sour.x,sour.y,sour1.x,sour1.y);
end;

{ - - - = = = * * * C A S * * * = = = - - -}

constructor tcas.init(ibarva,iradius:byte;isour:tsour);
begin
   barva:=ibarva;
   sour:=isour;
   radius:=iradius;
   SetTextStyle(DefaultFont, HorizDir, radius);
   vyska:=textheight('00:00:00');
   sirka:=textwidth('00:00:00');
   maxx:=(getmaxx-sirka);
   maxy:=(getmaxy-vyska);
   minx:=0;
   miny:=0;
end;

procedure tcas.kresli;
var hod,min,sec,seti: word;
    shod,smin,ssec:string[2];
    cas:string[10];
begin
   if udalost=2 then barva:=random(15);
   {setcolor(black);}
   SetTextStyle(DefaultFont, HorizDir, radius);
   {outtextxy(sour.x,sour.y,'00:00:00');}
   SetFillStyle(0,black);
   bar(sour.x,sour.y,sour.x+sirka,sour.y+vyska);
   if sour.x<=minx then begin
                      sour.x:=minx+1;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.x>=maxx then begin
                      sour.x:=maxx;
                      sour.dx:=-(sour.dx * (random(3)+1)) div abs(sour.dx);
                     end;
   if sour.y<=miny then begin
                      sour.y:=miny+1;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   if sour.y>=maxy then begin
                      sour.y:=maxy;
                      sour.dy:=-(sour.dy * (random(3)+1)) div abs(sour.dy);
                     end;
   sour.x:=sour.x+sour.dx;
   sour.y:=sour.y+sour.dy;
   gettime(hod,min,sec,seti);
   str(hod,shod);
   str(min,smin);
   str(sec,ssec);
   cas:='';
   insert(':'+ssec,cas,1);
   insert(':'+smin,cas,1);
   insert(shod,cas,1);
   setcolor(barva);
   outtextxy(sour.x,sour.y,cas);
end;

{ - - - = = = * * * P L O C H A * * * = = = - - -}

constructor tplocha.init(ibarva:byte);
begin
   barva:=ibarva;
end;

procedure tplocha.kresli;
begin
   setcolor(barva);
   SetTextStyle(DefaultFont, HorizDir,1);
   outtextxy(230,200,'Ukonci klavesou .. k');
   outtextxy(230,210,'Zmena barvy ...... b');
   outtextxy(230,220,'Ovladani cary .... sipky');
   rectangle(0,0,getmaxx,getmaxy);
end;

destructor tplocha.done;
begin
end;

{ - - - = = = * * * C E R V * * * = = = - - -}

constructor tcerv.init(ibarva:byte;isour:tsour);
begin
   barva:=ibarva;
   sour:=isour;
   maxx:=getmaxx;
   maxy:=getmaxy;
   minx:=0;
   miny:=0;
   rychlost:=4;
   uhel:=1;
end;

procedure tcerv.kresli;
begin
   if udalost=12 then begin
                        uhel:=uhel-1;
                        if uhel<0 then uhel:=11;
                      end;
   if udalost=13 then begin
                        uhel:=uhel+1;
                        if uhel>12 then uhel:=1;
                      end;
   if sour.x<=minx then begin
                      sour.x:=minx+1;
                      uhel:=random(12);
                     end;
   if sour.x>=maxx then begin
                      sour.x:=maxx;
                      uhel:=random(12);
                     end;
   if sour.y<=miny then begin
                      sour.y:=miny+1;
                      uhel:=random(12);
                      end;
   if sour.y>=maxy then begin
                      sour.y:=maxy;
                      uhel:=random(12);
                     end;
   sour.dx:=round(rychlost*cos(uhel*30*pi/180));
   sour.dy:=round(rychlost*sin(uhel*30*pi/180));
   setcolor(barva);
   line(sour.x,sour.y,sour.x+sour.dx,sour.y+sour.dy);
   sour.x:=sour.x+sour.dx;
   sour.y:=sour.y+sour.dy;
end;
{
function cti:char;
var reg :registers;
begin
  with reg do
  begin
    ah:=7;
    intr($21,reg);
    cti:=chr(al);
  end;
end;
}
{ - - - = = = * * * P R O G R A M * * * = = = - - -}

procedure main;
var
  a:tsour;
  kruh1:pkruh;
  kruh2:pkruh;
  cara1:pcara;
  cara2:pcara;
  ctverec1:pctverec;
  ctverec2:pctverec;
  cas1:pcas;
  cas2:pcas;
  plocha:pplocha;
  cerv:pcerv;
begin
 a.x:=300;
 a.y:=300;
 a.dx:=1;
 a.dy:=2;
kruh1:= new(pkruh,init(green,20,a));
kruh2:= new(pkruh,init(yellow,45,a));
cara1:= new(pcara,init(white,a,a));
cara2:= new(pcara,init(yellow,a,a));
ctverec1:= new(pctverec,init(green,35,a));
ctverec2:= new(pctverec,init(red,40,a));
cas1:= new(pcas,init(yellow,1,a));
cas2:=new(pcas,init(blue,2,a));
plocha:=new(pplocha,init(darkgray));
cerv:=new(pcerv,init(red,a));
 repeat
  plocha^.kresli;
  cas1^.kresli;
  cas2^.kresli;
  kruh1^.kresli;
  kruh2^.kresli;
  cara1^.kresli;
  cara2^.kresli;
  ctverec1^.kresli;
  ctverec2^.kresli;
  cerv^.kresli;
  udalost:=0;
  if keypressed then case readkey of
                            chr(0): case readkey of
                                    chr(72): udalost:=10;{nahoru}
                                    chr(80): udalost:=11;{dolu}
                                    chr(75): udalost:=12;{doleva}
                                    chr(77): udalost:=13;{doprava}
                                    end;
                            'k': udalost:=1;
                            'b': udalost:=2;
                          end;
  delay(20);
  until udalost=1;
 dispose(kruh1,done);
 dispose(kruh2,done);
 dispose(cara1,done);
 dispose(cara2,done);
 dispose(ctverec1,done);
 dispose(ctverec2,done);
 dispose(cas1,done);
 dispose(cas2,done);
 dispose(plocha,done);
 dispose(cerv,done);
end;


var
 grDriver: Integer;
 grMode: Integer;
begin
 grDriver := Detect;
 InitGraph(grDriver, grMode,'');
 main;
 CloseGraph;
end.
